/**
 * Copyright 2019 DH
 * All right reserved.
 * 项目名称: 运维系统
 * 创建日期:2022/8/28
 */
package org.springblade.modules.business.data.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springblade.constant.BusinessConstant;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.baseinfo.org.entity.DeptRegionEntity;
import org.springblade.modules.baseinfo.org.service.IDeptRegionService;
import org.springblade.modules.baseinfo.region.entity.RegionTreeNodeEntity;
import org.springblade.modules.baseinfo.region.service.IBaseInfoRegionService;
import org.springblade.modules.business.data.dto.RtuDataRainDTO;
import org.springblade.modules.business.data.entity.RtuDataRainEntity;
import org.springblade.modules.business.data.service.IRtuDataRainService;
import org.springblade.modules.business.data.vo.RtuDataRainVO;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import springfox.documentation.annotations.ApiIgnore;

import java.util.List;


/***
 * Date:2022/8/28
 * Title:文件所属模块（必须填写）
 * Description：对本文件的详细描述，原则上不能少于30字
 * @author dylan
 * @version 1.0
 * Remark：认为有必要的其他信息
 */
@RestController
@RequestMapping("galaxy-business/rtu/data/rain")
@AllArgsConstructor
@Api(value = "降水实时数据管理", tags = "测站实时数据管理")
public class RtuDataRainController extends BladeController {
	private final IRtuDataRainService dataRainService;
	private final IDeptRegionService deptRegionService;
    private final IBaseInfoRegionService regionService;
	/**
	 * 分页
	 */
	@GetMapping("/page")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "rtuName", value = "测站名称", paramType = "query", dataType = "string"),
		@ApiImplicitParam(name = "rtuCode", value = "测站编码", paramType = "query", dataType = "string"),
		@ApiImplicitParam(name = "adCode", value = "行政区划编码", paramType = "query", dataType = "string"),
		@ApiImplicitParam(name = "rainCountType", value = "雨量统计类型", paramType = "query", dataType = "int"),
	})
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页")
	public R<IPage<RtuDataRainVO>> page(@ApiIgnore RtuDataRainDTO rtuDataRainDTO, Query query) {
		BladeUser user = AuthUtil.getUser();
		if (BusinessConstant.ROLE_SYS_ADMIN.equals(user.getRoleName())) {
			if (rtuDataRainDTO.getAdCode() == null) {
				rtuDataRainDTO.setAdCode(BusinessConstant.REGION_NM_ADCODE);
			}
		} else if (BusinessConstant.ROLE_ORG_ADMIN.equals(user.getRoleName()) || BusinessConstant.ROLE_COMPANY_ADMIN.equals(user.getRoleName()) || BusinessConstant.ROLE_COMPANY_SERVICE_PERSON.equals(user.getRoleName())) {
			if (rtuDataRainDTO.getAdCode() == null) {
				LambdaQueryWrapper<DeptRegionEntity> deptRegionEntityLambdaQueryWrapper = Wrappers.<DeptRegionEntity>query().lambda();
				deptRegionEntityLambdaQueryWrapper.eq(DeptRegionEntity::getIsDeleted, 0);
				deptRegionEntityLambdaQueryWrapper.eq(DeptRegionEntity::getDeptId, Func.toLong(user.getDeptId()));
				DeptRegionEntity deptRegionEntity = deptRegionService.getOne(deptRegionEntityLambdaQueryWrapper);
				rtuDataRainDTO.setAdCode(deptRegionEntity.getAdcd());
			}
		}
		if (rtuDataRainDTO.getAdCode() != null) {
			RegionTreeNodeEntity node = this.regionService.getRegionNode(user.getRoleName(), user.getDeptId(), rtuDataRainDTO.getAdCode());
			if (null != node) {
				rtuDataRainDTO.setExcludeCode(node.getExclude());
			}
		}
		IPage<RtuDataRainVO> pages = dataRainService.selectPage(Condition.getPage(query), rtuDataRainDTO);
		List<RtuDataRainVO> list = pages.getRecords();
		for(RtuDataRainVO vo:list){
			if(rtuDataRainDTO.getRainCountType()!=null){
				if(rtuDataRainDTO.getRainCountType()==1){
					vo.setIntvLable("近1小时");
					vo.setDrp(vo.getH1drp());
					vo.setTm(vo.getH1tm());
				}else if(rtuDataRainDTO.getRainCountType()==3){
					vo.setIntvLable("近3小时");
					vo.setDrp(vo.getH3drp());
					vo.setTm(vo.getH3tm());
				}else if(rtuDataRainDTO.getRainCountType()==6){
					vo.setIntvLable("近6小时");
					vo.setDrp(vo.getH6drp());
					vo.setTm(vo.getH6tm());
				}else if(rtuDataRainDTO.getRainCountType()==12){
					vo.setIntvLable("近12小时");
					vo.setDrp(vo.getH12drp());
					vo.setTm(vo.getH12tm());
				}else if(rtuDataRainDTO.getRainCountType()==24){
					vo.setIntvLable("近24小时");
					vo.setDrp(vo.getH24drp());
					vo.setTm(vo.getH24tm());
				}else{
					if(vo.getIntv() !=null && vo.getIntv()==0.05){
						vo.setIntvLable("5分钟");
					}else if(vo.getIntv()!=null &&  vo.getIntv()==1.0){
						vo.setIntvLable("小时");
					}
				}
			}else{
				if(vo.getIntv() !=null && vo.getIntv()==0.05){
					vo.setIntvLable("5分钟");
				}else if(vo.getIntv()!=null &&  vo.getIntv()==1.0){
					vo.setIntvLable("小时");
				}
			}
		}
		return R.data(pages);
	}


	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "rtuCode", value = "测站编码", paramType = "query", dataType = "string"),
	})
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入 RtuDataRainEntity")
	public R<RtuDataRainEntity> detail(RtuDataRainEntity entity) {
		LambdaQueryWrapper<RtuDataRainEntity> wrapper = Wrappers.<RtuDataRainEntity>query().lambda();
		wrapper.eq(RtuDataRainEntity::getIsDeleted, 0L);
		wrapper.eq(RtuDataRainEntity::getRtuCode, entity.getRtuCode());
		RtuDataRainEntity rainEntity = dataRainService.getOne(wrapper);
		return R.data(rainEntity);
	}
}
